# Class `wibox.layout.fixed`

### Usage:

    wibox.widget {
        generic_widget( 'first'  ),
        generic_widget( 'second' ),
        generic_widget( 'third'  ),
        layout  = wibox.layout.fixed.horizontal
    }

### Info:

- Copyright: 2010 Uli Schlachter
- Author: Uli Schlachter

## Functions

wibox.layout.fixed.horizontal (...) | Returns a new horizontal fixed layout.
wibox.layout.fixed.vertical (...) | Returns a new vertical fixed layout.

## Object properties

wibox.layout.fixed.children | Get all direct children of this layout.
wibox.layout.fixed.fill_space | Set the layout's fill_space property.
wibox.layout.fixed.spacing | Add spacing between each layout widgets
wibox.layout.fixed.forced_height | Force a widget height.
wibox.layout.fixed.forced_width | Force a widget width.
wibox.layout.fixed.opacity | The widget opacity (transparency).
wibox.layout.fixed.visible | The widget visibility.

## Signals

widget::layout_changed | When the layout (size) change.
widget::redraw_needed | When the widget content changed.
button::press | When a mouse button is pressed over the widget.
button::release | When a mouse button is released over the widget.
mouse::enter | When the mouse enter a widget.
mouse::leave | When the mouse leave a widget.

## Methods

wibox.layout.fixed:set (index, widget2) | Set a widget at a specific index, replace the current one.
wibox.layout.fixed:replace_widget (widget, widget2[, recursive=false]) | Replace the first instance of `widget` in the layout with `widget2`.
wibox.layout.fixed:swap (index1, index2) | Swap 2 widgets in a layout.
wibox.layout.fixed:swap_widgets (widget1, widget2[, recursive=false]) | Swap 2 widgets in a layout.
wibox.layout.fixed:reset (layout) | Reset a ratio layout.
wibox.layout.fixed:add (...) | Add some widgets to the given fixed layout
wibox.layout.fixed:remove (index) | Remove a widget from the layout
wibox.layout.fixed:remove_widgets (widget) | Remove one or more widgets from the layout The last parameter can be a boolean, forcing a recursive seach of the widget(s) to remove.
wibox.layout.fixed:replace_widget (widget, widget2[, recursive=false]) | Replace the first instance of `widget` in the layout with `widget2`
wibox.layout.fixed:insert (index, widget) | Insert a new widget in the layout at position index Signal: widget::inserted The arguments are the widget and the index
wibox.layout.fixed:index (widget[, recursive[, ...]]) | Get a widex index.
wibox.layout.fixed:get_all_children () | Get all direct and indirect children widgets.
wibox.layout.fixed:setup (args) | Set a declarative widget hierarchy description.
wibox.layout.fixed:buttons (_buttons) | Set/get a widget's buttons.
wibox.layout.fixed:emit_signal_recursive (signal_name, ...) | Emit a signal and ensure all parent widgets in the hierarchies also forward the signal.
wibox.layout.fixed:disconnect_signal (name, func) | Disconnect to a signal.
wibox.layout.fixed:emit_signal (name, ...) | Emit a signal.
wibox.layout.fixed:connect_signal (name, func) | Connect to a signal.
wibox.layout.fixed:weak_connect_signal (name, func) | Connect to a signal weakly.

## Functions

Methods

wibox.layout.fixed.horizontal (...)
  Returns a new horizontal fixed layout. Each widget will get as much space as it asks for and each widget will be drawn next to its neighboring widget. Widgets can be added via :add() or as arguments to this function.
  - ... widget Widgets that should be added to the layout.
wibox.layout.fixed.vertical (...)
  Returns a new vertical fixed layout. Each widget will get as much space as it asks for and each widget will be drawn next to its neighboring widget. Widgets can be added via :add() or as arguments to this function.
  - ... widget Widgets that should be added to the layout.

## Object properties

wibox.layout.fixed.children
  Get all direct children of this layout.

  ### Type:

  - layout The layout you are modifying.
wibox.layout.fixed.fill_space
  Set the layout's fill_space property. If this property is true, the last widget will get all the space that is left. If this is false, the last widget won't be handled specially and there can be space left unused.
wibox.layout.fixed.spacing
  Add spacing between each layout widgets

  ### Type:

  - spacing number Spacing between widgets.
wibox.layout.fixed.forced_height
  Force a widget height.

  ### Type:

  - height number or nil The height (`nil` for automatic)
wibox.layout.fixed.forced_width
  Force a widget width.

  ### Type:

  - width number or nil The width (`nil` for automatic)
wibox.layout.fixed.opacity
  The widget opacity (transparency).

  ### Type:

  - opacity number The opacity (between 0 and 1) (default 1)
wibox.layout.fixed.visible
  The widget visibility.

  ### Type:

  - boolean

## Signals

widget::layout_changed
  When the layout (size) change. This signal is emitted when the previous results of `:layout()` and `:fit()` are no longer valid. Unless this signal is emitted, `:layout()` and `:fit()` must return the same result when called with the same arguments.

  ### See also:

  widget::redraw_needed
widget::redraw_needed
  When the widget content changed. This signal is emitted when the content of the widget changes. The widget will be redrawn, it is not re-layouted. Put differently, it is assumed that `:layout()` and `:fit()` would still return the same results as before.

  ### See also:

  widget::layout_changed
button::press
  When a mouse button is pressed over the widget.

  ### Arguments:

  - lx number The horizontal position relative to the (0,0) position in the widget.
  - ly number The vertical position relative to the (0,0) position in the widget.
  - button number The button number.
  - mods table The modifiers (mod4, mod1 (alt), Control, Shift)
  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse
button::release
  When a mouse button is released over the widget.

  ### Arguments:

  - lx number The horizontal position relative to the (0,0) position in the widget.
  - ly number The vertical position relative to the (0,0) position in the widget.
  - button number The button number.
  - mods table The modifiers (mod4, mod1 (alt), Control, Shift)
  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse
mouse::enter
  When the mouse enter a widget.

  ### Arguments:

  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse
mouse::leave
  When the mouse leave a widget.

  ### Arguments:

  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse

## Methods

wibox.layout.fixed:set (index, widget2)
  Set a widget at a specific index, replace the current one. Signal: widget::replaced The argument is the new widget and the old one and the index.
  - index number A widget or a widget index
  - widget2 The widget to take the place of the first one

  ### Returns:

  boolean If the operation is successful
wibox.layout.fixed:replace_widget (widget, widget2[, recursive=false])
  Replace the first instance of `widget` in the layout with `widget2`. Signal: widget::replaced The argument is the new widget and the old one and the index.
  - widget The widget to replace
  - widget2 The widget to replace `widget` with
  - recursive boolean Digg in all compatible layouts to find the widget. (default false)

  ### Returns:

  boolean If the operation is successful
wibox.layout.fixed:swap (index1, index2)
  Swap 2 widgets in a layout. Signal: widget::swapped The arguments are both widgets and both (new) indexes.
  - index1 number The first widget index
  - index2 number The second widget index

  ### Returns:

  boolean If the operation is successful
wibox.layout.fixed:swap_widgets (widget1, widget2[, recursive=false])
  Swap 2 widgets in a layout. If widget1 is present multiple time, only the first instance is swapped Signal: widget::swapped The arguments are both widgets and both (new) indexes. if the layouts not the same, then only `widget::replaced` will be emitted.
  - widget1 The first widget
  - widget2 The second widget
  - recursive boolean Digg in all compatible layouts to find the widget. (default false)

  ### Returns:

  boolean If the operation is successful
wibox.layout.fixed:reset (layout)
  Reset a ratio layout. This removes all widgets from the layout. Signal: widget::reset
  - layout The layout you are modifying.
wibox.layout.fixed:add (...)
  Add some widgets to the given fixed layout
  - ... Widgets that should be added (must at least be one)
wibox.layout.fixed:remove (index)
  Remove a widget from the layout
  - index number The widget index to remove

  ### Returns:

  boolean index If the operation is successful
wibox.layout.fixed:remove_widgets (widget)
  Remove one or more widgets from the layout The last parameter can be a boolean, forcing a recursive seach of the widget(s) to remove.
  - widget ... Widgets that should be removed (must at least be one)

  ### Returns:

  boolean If the operation is successful
wibox.layout.fixed:replace_widget (widget, widget2[, recursive=false])
  Replace the first instance of `widget` in the layout with `widget2`
  - widget The widget to replace
  - widget2 The widget to replace `widget` with
  - recursive boolean Digg in all compatible layouts to find the widget. (default false)

  ### Returns:

  boolean If the operation is successful
wibox.layout.fixed:insert (index, widget)
  Insert a new widget in the layout at position index Signal: widget::inserted The arguments are the widget and the index
  - index number The position
  - widget The widget

  ### Returns:

  boolean If the operation is successful
wibox.layout.fixed:index (widget[, recursive[, ...]])
  Get a widex index.
  - widget The widget to look for
  - recursive Also check sub-widgets (optional)
  - ... Aditional widgets to add at the end of the \"path\" (optional)

  ### Returns:

  1. The index
  2. The parent layout
  3. The path between \"self\" and \"widget\"
wibox.layout.fixed:get_all_children ()
  Get all direct and indirect children widgets. This will scan all containers recursively to find widgets Warning: This method it prone to stack overflow id the widget, or any of its children, contain (directly or indirectly) itself.

  ### Returns:

  table The children
wibox.layout.fixed:setup (args)
  Set a declarative widget hierarchy description. See The declarative layout system
  - args An array containing the widgets disposition
wibox.layout.fixed:buttons (_buttons)
  Set/get a widget's buttons.
  - _buttons The table of buttons that should bind to the widget.
wibox.layout.fixed:emit_signal_recursive (signal_name, ...)
  Emit a signal and ensure all parent widgets in the hierarchies also forward the signal. This is useful to track signals when there is a dynamic set of containers and layouts wrapping the widget.
  - signal_name string
  - ... Other arguments
wibox.layout.fixed:disconnect_signal (name, func)
  Disconnect to a signal.
  - name string The name of the signal
  - func function The callback that should be disconnected
wibox.layout.fixed:emit_signal (name, ...)
  Emit a signal.
  - name string The name of the signal
  - ... Extra arguments for the callback functions. Each connected function receives the object as first argument and then any extra arguments that are given to emit_signal()
wibox.layout.fixed:connect_signal (name, func)
  Connect to a signal.
  - name string The name of the signal
  - func function The callback to call when the signal is emitted
wibox.layout.fixed:weak_connect_signal (name, func)
  Connect to a signal weakly. This allows the callback function to be garbage collected and automatically disconnects the signal when that happens.

  Warning: Only use this function if you really, really, really know what you are doing.

  - name string The name of the signal
  - func function The callback to call when the signal is emitted

generated by LDoc 1.4.6 Last updated 2017-01-20 01:17:18